package uibk.applets.riemann3d;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.Locale;

import javax.swing.JLabel;

import uibk.mtk.lang.Messages;
import uibk.mtk.swing.base.TitledPanel;

/**
 * Panel f?r die Ausgabe der Integrationsumme, Fehler,exakter Wert
 * 
 * 
 * <p>
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2006
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
public class PanelOutput extends TitledPanel {

	/** Erzeugt den Panel */
	public PanelOutput() {
		super(Messages.getString(AppletRiemann3D.BUNDLE_NAME, "PanelOutput.0")); //$NON-NLS-1$

		initComponents();

	}

	/** Zahlenformat f?r die Formatierung der Ergebnisse */
	DecimalFormat format = new DecimalFormat("0.0000000000", //$NON-NLS-1$
			new DecimalFormatSymbols(Locale.US));

	/** Label f?r die aktuelle Integrationssumme oder Obersumme */
	JLabel labelsum = new JLabel(""); //$NON-NLS-1$

	/** Label fr die aktuelle Integrationssumme oder Untersumme */
	JLabel labelsum1 = new JLabel(""); //$NON-NLS-1$

	/** Label f?r Untersumme falls Ober- und Untersumme gew?hlt ist */
	JLabel labelsubdiv = new JLabel(""); //$NON-NLS-1$

	/** Label f?r den exakten Wert des Integrals */
	JLabel labelexact = new JLabel(""); //$NON-NLS-1$

	/** Label f?r den Fehler der Integrationssumme oder Obersumme */
	JLabel labelerror = new JLabel(""); //$NON-NLS-1$

	/** Label f?r den Fehler der Untersumme */
	JLabel labelerror1 = new JLabel(""); //$NON-NLS-1$

	/** Formatierungsfarbe */
	private static String FORMATCOLOR = "blue"; //$NON-NLS-1$

	/** exakter Wert des Integrals */
	double exactvalue = 0;

	/** Initialisieren der Komponenten */
	void initComponents() {

		// Layout
		setLayout(new GridBagLayout());

		// Label hinzuf?gen
		add(labelsubdiv, new GridBagConstraints(0, 0, 1, 1, 1.0, 0,
				GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL,
				new Insets(5, 5, 5, 5), 0, 0));
		add(labelsum, new GridBagConstraints(0, 1, 1, 1, 1.0, 0,
				GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL,
				new Insets(5, 5, 5, 5), 0, 0));
		add(labelerror, new GridBagConstraints(0, 2, 1, 1, 1.0, 0,
				GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL,
				new Insets(5, 5, 5, 5), 0, 0));
		add(labelsum1, new GridBagConstraints(1, 1, 1, 1, 1.0, 0,
				GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL,
				new Insets(5, 5, 5, 5), 0, 0));
		add(labelerror1, new GridBagConstraints(1, 2, 1, 1, 1.0, 0,
				GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL,
				new Insets(5, 5, 5, 5), 0, 0));
		add(labelexact, new GridBagConstraints(1,0, 1, 1, 1.0, 0,
				GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL,
				new Insets(5, 5, 5, 5), 0, 0));

	}

	/**
	 * Erzeugt die Ausgabe
	 */
	public void createOutput(double sum, int s, int t) {

		labelerror1.setVisible(false);
		labelsum1.setVisible(false);
		String n = String.valueOf(s);
		labelsubdiv.setText(makeString(Messages.getString(
				AppletRiemann3D.BUNDLE_NAME, "PanelOutput.7"), n)); //$NON-NLS-1$
		if (t==1) {
			labelsum.setText(makeString(Messages.getString(
					AppletRiemann3D.BUNDLE_NAME, "PanelOutput.13"), format //$NON-NLS-1$
					.format(sum)));
			labelerror
					.setText(makeString(
							Messages.getString(AppletRiemann3D.BUNDLE_NAME,
									"PanelOutput.14"), format.format(Math //$NON-NLS-1$
									.abs(exactvalue - sum))));

		} else {
			labelsum.setText(makeString(Messages.getString(
					AppletRiemann3D.BUNDLE_NAME, "PanelOutput.15"), format //$NON-NLS-1$
					.format(sum)));
			labelerror
					.setText(makeString(
							Messages.getString(AppletRiemann3D.BUNDLE_NAME,
									"PanelOutput.16"), format.format(Math //$NON-NLS-1$
									.abs(exactvalue - sum))));

		}

		labelexact.setText(makeString(
				Messages.getString(AppletRiemann3D.BUNDLE_NAME,
						"PanelOutput.10"), format.format(exactvalue))); //$NON-NLS-1$

	}

	/**
	 * Erzeugt die Ausgabe
	 */
	public void createOutput(double sumup, double sumdown, int s) {

		labelerror1.setVisible(true);
		labelsum1.setVisible(true);
		String n = String.valueOf(s);
		labelsubdiv.setText(makeString(Messages.getString(
				AppletRiemann3D.BUNDLE_NAME, "PanelOutput.7"), n)); //$NON-NLS-1$
		labelsum.setText(makeString(Messages.getString(
				AppletRiemann3D.BUNDLE_NAME, "PanelOutput.8"), format //$NON-NLS-1$
				.format(sumup)));
		labelerror
				.setText(makeString(
						Messages.getString(AppletRiemann3D.BUNDLE_NAME,
								"PanelOutput.9"), format.format(Math //$NON-NLS-1$
								.abs(exactvalue - sumup))));
		labelsum1.setText(makeString(Messages.getString(
				AppletRiemann3D.BUNDLE_NAME, "PanelOutput.11"), format //$NON-NLS-1$
				.format(sumdown)));
		labelerror1.setText(makeString(
				Messages.getString(AppletRiemann3D.BUNDLE_NAME,
						"PanelOutput.12"), format.format(Math //$NON-NLS-1$
						.abs(exactvalue - sumdown))));
		labelexact.setText(makeString(
				Messages.getString(AppletRiemann3D.BUNDLE_NAME,
						"PanelOutput.10"), format.format(exactvalue))); //$NON-NLS-1$

	}

	/**
	 * l?scht den Text aller Labels
	 * 
	 */
	public void clear() {

		labelsum.setText(""); //$NON-NLS-1$
		labelsubdiv.setText(""); //$NON-NLS-1$
		labelsum1.setText(""); //$NON-NLS-1$
		labelerror.setText(""); //$NON-NLS-1$
		labelerror1.setText(""); //$NON-NLS-1$
		labelexact.setText(""); //$NON-NLS-1$

	}

	/**
	 * Erzeugt einen String der Form <html><font color=FORMATCOLOR>name:
	 * </font>value"
	 */
	String makeString(String name, String value) {

		String str = "<html><font color=" + FORMATCOLOR + ">" + name //$NON-NLS-1$ //$NON-NLS-2$
				+ ": </font>" + value; //$NON-NLS-1$

		return str;
	}

	/** Setzt den exakten Wert des Integrals */
	public void setExactValue(double v) {
		this.exactvalue = v;
	}

}