package uibk.mtk.draw3d.base;

import java.awt.Graphics2D;

import uibk.mtk.draw3d.rasterizer.Rasterizer;

/**
 * Ein <CODE>RMathPanel3D</CODE> ist ein <CODE>MathPanel3D</CODE> zu dem
 * zus?tzlich <CODE>Rasterable3D</CODE> -Objekte hinzugef?gt werden k?nnen.
 * <p>
 * 
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2003
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
public class RMathPanel3D extends MathPanel3D {

	/** Objekt zur Rasterkonvertierung */
	private Rasterizer rasterizer = new Rasterizer();

	public RMathPanel3D() {
		super();

	}

	/** Vorbereiten der Buffer */
	protected void preparebuffer() {
		super.preparebuffer();
		Graphics2D g2 = framebuffer.createGraphics();
		options.setRenderingHints(g2);
		rasterizer.setBuffers(framebuffer, g2, zbuffer);
	}

	/** Gibt das Objekt zur Rasterkonvertierung zur?ck */
	public Rasterizer getRasterizer() {
		return rasterizer;
	}

	/**
	 * HInzuf?gen eines <CODE>Drawable3D</CODE> Objekts. Falls das Objekt ein
	 * <CODE>Rasterable3D</CODE> ist, wird das Objekt zum Rastern gesetzt.
	 */
	public synchronized void add(Object obj) {
		super.add(obj);

		if (obj != null && (obj instanceof Rasterable3D)) {
			((Rasterable3D) obj).setRasterizer(rasterizer);
		}
	}

}