package uibk.mtk.draw3d.objects.surface3d;

import java.awt.Color;
import java.util.Iterator;

import uibk.mtk.geom.geom3d.CoordinateBox3D;
import uibk.mtk.math.MathUtil;

/**
 * Ein Farbmodell das die Vertice nach ihrer z-Koordinate f?rbt.
 * 
 * <p>
 * Die Farbe f?r einen Vertex wird durch lineare Interpolation nach der
 * z-Koordinate bestimmt wobei f?r die minimale und maximale z-Koordinate eine
 * Farbe gegeben ist bzw. gesetzt werden kann.
 * </p>
 * 
 * 
 * <p>
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2003
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
public class ColorModelXY extends ColorModel {

	public void colorVertices(Iterator it, CoordinateBox3D cube) {
		while (it.hasNext()) {

			Vertex3D vertex = (Vertex3D) it.next();

			int r = (int) MathUtil.interpolate(cube.xmin, cube.xmax, 10, 240,
					vertex.mc.x1);
			int g = (int) MathUtil.interpolate(cube.ymin, cube.ymax, 10, 240,
					vertex.mc.x2);
			vertex.color = new Color(r, g, 100);

		}
	}
}