package uibk.mtk.draw3d.objects.surface3d;

import uibk.mtk.geom.geom3d.Vector3D;

/**
 * Klasse f?r ein Dreieck im Raum
 * <p>
 * Die Klasse implementiert das Interface Comparable um die Dreicke nach ihrer
 * Tiefe mit der Standardbibilothek sortieren zu k?nnen
 * </p>
 * 
 * <p>
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2003
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
public class Triangle implements Comparable {

	/** Die Eckpunkte des Dreiecks */
	public Vertex3D p1, p2, p3;

	/** Die Distanz zum Betrachter */
	public double distance;

	/** Der Normalenvektor des Dreiecks in Weltkoordinaten */
	public Vector3D normal;

	/** Erzeugt das Dreieck aus drei Eckpunkten */
	public Triangle(Vertex3D p1, Vertex3D p2, Vertex3D p3) {
		this.p1 = p1;
		this.p2 = p2;
		this.p3 = p3;
	}

	/** Implementierung des Comparable Interfaces */
	public int compareTo(Object o) {
		if (distance < ((Triangle) o).distance)
			return 1;
		else if (distance > ((Triangle) o).distance)
			return -1;
		else
			return 0;
	}

}