package uibk.mtk.draw3d.objects.surface3d;

import java.awt.Color;
import java.awt.Point;

import uibk.mtk.geom.geom3d.Punkt3D;
import uibk.mtk.geom.geom3d.Vector3D;

/**
 * Vertex im Raum
 * 
 * <p>
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2003
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
public class Vertex3D {

	/** Modellkoordinaten des Vertex */
	public Punkt3D mc = new Punkt3D();

	/** Weltkoordinaten des Vertex */
	public Punkt3D wc;

	/** Ger?tekoordinaten des Vertex */
	public Point dc;

	/** Farbe des Vertex */
	public Color color;

	/** Entfernung von Kamera (f?r z-Buffer) */
	public double distance;

	/** Normalvektor im Vertex (in Weltkoordinaten) */
	public Vector3D n = new Vector3D();

	/** Erzeugt einen Vertex mit den ?bergebenen (Model-)Koordinaten */
	public Vertex3D(double x1, double x2, double x3) {
		mc.x1 = x1;
		mc.x2 = x2;
		mc.x3 = x3;
	}

	/** Erzeugt einen Vertex mit den (Model-)Koordinaten des Punktes p */
	public Vertex3D(Punkt3D p) {
		mc.x1 = p.x1;
		mc.x2 = p.x2;
		mc.x3 = p.x3;
	}

	/** Erzeugt einen Vertex mit den (Model-)Koordinaten (0,0,0) */
	public Vertex3D() {
	}

}