package uibk.mtk.geom.geom2d;

/**
 * Ein Vektor in der Ebene gegeben durch x,y Koordinaten in doppelter
 * Genauigkeit
 * 
 * <p>
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2003
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
public class Vector2D extends Punkt2D {

	/** 1. Einheitsvektor (1,0) */
	public static final Vector2D E1 = new Vector2D(1, 0);

	/** 2. Einheitsvektor (0,1) */
	public static final Vector2D E2 = new Vector2D(0, 1);

	/** Erzeugt einen Vector2D mit den angegebenen Koordinaten */
	public Vector2D(double x, double y) {
		super(x, y);
	}

	/** Erzeugt Vector2D mit den Koordinaten (0,0) */
	public Vector2D() {
		super();
	}

	/** Copy-Konstruktor */
	public Vector2D(Vector2D v) {
		super(v.x, v.y);
	}

	/**
	 * gibt einen Vector2D in Einheitsl?nge zur?ck, der normal auf den aktuellen
	 * Vektor steht.
	 */
	public Vector2D normaldir() {
		double n = norm();
		return new Vector2D(-y / n, x / n);
	}

	/** Erstellt eine Kopie des Punktes */
	public Object clone() {
		return new Vector2D(x, y);
	}

}