package uibk.mtk.math.functions;

import uibk.mtk.geom.geom2d.Punkt2D;
import uibk.mtk.geom.geom2d.Vector2D;

/**
 * Interface f?r eine reelle Funktion von R^2->R
 * <p>
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2003
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
public interface Function2D {

	/**
	 * gibt den Wert der Funktion an der Stelle (0,y) zur?ck.
	 */
	abstract public double getValue(double x, double y);

	/**
	 * Richtungsabeleitung im Punkt a in Richtung v Pr?fung auf Diffbarkeit wie
	 * in Klasse Derivations
	 * 
	 * @param a
	 *            Punkt an dem die Richtungsableitung berechnet werden soll
	 * @param v
	 *            Richtungsvektor
	 * @return
	 * @throws Exception
	 *             Exception beim Differenzieren
	 */
	abstract public double getDerivate(Punkt2D a, Vector2D v) throws Exception;

}