package uibk.mtk.math.functions;

/**
 * Klasse die eine Funktion von R->R implementiert und durch Benutzereingaben
 * bestimmt wird.
 * <p>
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2003
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
import uibk.mtk.parser.realparser.Expr;
import uibk.mtk.parser.realparser.Variable;

public class ParsedFunction1D extends ParsedFunction implements Function1D {

	/** Erzeugt die Funktion */
	public ParsedFunction1D(Variable var, Expr function) {
		super(new Variable[] { var }, new Expr[] { function });

	}

	/** Berechnet den Wert der Funktion x */
	public double getValue(double x) {

		double[] v = getValue(new double[] { x });
		return v[0];
	}

	/** Berechnet den Wert der Ableitung an der Stelle x */
	public double getDerivation(double param) throws Exception {
		double[] var = { param };
		double[][] jacob = getJacobian(var);
		return jacob[0][0];

	}

}