package uibk.mtk.math.parsing;

import uibk.mtk.math.functions.ParsedFunction;

/**
 * Utilityklasse zum Parsen von beliebigen reellen Funktion von R^n->R^m.
 * 
 * 
 * 
 * <p>
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2003
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
public final class FunctionParser {

	private FunctionParser() {
		super();

	}

	/**
	 * Parst die durch <CODE>strFunctions</CODE> definiert Funktion.
	 * 
	 * @param strVars
	 *            die erlaubten Variablen
	 * @param strFunctions
	 *            mathematische Ausdr?cke in den Variablen
	 * @throws Exception
	 *             die vom Parser geworfenen Exceptions
	 */
	public static synchronized ParsedFunction parseFunction(String[] strVars,
			String[] strFunctions) throws Exception {

		ParsingResult ret = RealExpressionParser.parseFunction(strVars,
				strFunctions);

		//Setzen der Funktion
		return new ParsedFunction(ret.variables, ret.expressions);

	}

}