package uibk.mtk.swing.base;

import java.awt.event.ActionListener;

import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.JRadioButton;

/**
 * Von JRadioButton abgeleitete Klasse, die alle Konstruktoren der Superklasse
 * und noch einen eigenen implementiert.
 * 
 * <p>
 * Copyright: Institut f?r Technische Mathematik, Geometrie und Bauinformatik,
 * 2003
 * </p>
 * 
 * @author Markus Unterweger (markus.unterweger@aon.at)
 */
public class RadioButton extends JRadioButton {

	/** siehe {@link javax.swing.JRadioButton#JRadioButton()} */
	public RadioButton() {
		super();

	}

	/** siehe {@link javax.swing.JRadioButton#JRadioButton(String)} */
	public RadioButton(String text) {
		super(text);

	}

	/** siehe {@link javax.swing.JRadioButton#JRadioButton(String,boolean)} */
	public RadioButton(String text, boolean selected) {
		super(text, selected);

	}

	/** siehe {@link javax.swing.JRadioButton#JRadioButton(Action)} */
	public RadioButton(Action a) {
		super(a);

	}

	/** siehe {@link javax.swing.JRadioButton#JRadioButton(Icon)} */
	public RadioButton(Icon icon) {
		super(icon);

	}

	/** siehe {@link javax.swing.JRadioButton#JRadioButton(Icon,boolean)} */
	public RadioButton(Icon icon, boolean selected) {
		super(icon, selected);

	}

	/** siehe {@link javax.swing.JRadioButton#JRadioButton(String,Icon)} */
	public RadioButton(String text, Icon icon) {
		super(text, icon);

	}

	/** siehe {@link javax.swing.JRadioButton#JRadioButton(String,Icon,boolean)} */
	public RadioButton(String text, Icon icon, boolean selected) {
		super(text, icon, selected);

	}

	/**
	 * Erzeugt einen RadioButton
	 * 
	 * @param text
	 *            Beschriftung
	 * @param actioncommand
	 *            actioncommand f?r den RadioButton
	 * @param actionlistener
	 *            <CODE>ActionListener</CODE> f?r den RadioButton
	 * @param tooltip
	 *            <CODE>Tooltip</CODE>
	 */
	public RadioButton(String text, String actioncommand,
			ActionListener actionlistener, String tooltip) {
		super(text);
		setActionCommand(actioncommand);
		addActionListener(actionlistener);
		setToolTipText(tooltip);

	}

}